Bug 114886 - [Sidebar: Styles and formatting] Implementing the styles views as filters
Summary: [Sidebar: Styles and formatting] Implementing the styles views as filters
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
: 131556 144727 151109 (view as bug list)
Depends on:
Blocks: Sidebar-Styles Sidebar-Styles-Filter
  Show dependency treegraph
 
Reported: 2018-01-07 16:27 UTC by Frank Brütting
Modified: 2022-10-07 15:31 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
Hierarchical tree branch view in another word-processor (19.36 KB, image/png)
2018-03-20 18:17 UTC, Eric Bright
Details
Applied Styles view in LibreOffice Writer version 6.0.2.1 on Windows 10 (as of 2018-03-20) (27.09 KB, image/png)
2018-03-20 21:14 UTC, Eric Bright
Details
Heirarchical view in LibreOffice Writer version 6.0.2.1 on Windows 10 (as of 2018-03-20) (48.79 KB, image/png)
2018-03-20 21:36 UTC, Eric Bright
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Frank Brütting 2018-01-07 16:27:08 UTC
Description:
I don’t know if this applies to most users, but at least in my case, I mostly use either the “hierarchical” view or “used styles”, and often switch between both (as I work with a lot of small documents, so my typical styles often aren’t already listed in “used styles”). I experienced several drawbacks here:

• “Hierarchical” is a view mode, with all other entries being filters in contrast (⇒ sloppy implementation?).

• Therefore, displaying “used styles” in a hierarchical view isn’t possible.

• Switching between two views is quite cumbersome, because you have to perform three actions for every transition:
    – Opening the view modes ComboBox.
    – Searching the wanted display mode.
    – Selecting it.


For solving all the above mentioned issues, I think it’s a good idea to split the current implementation into two parts (like the MVC principle):

• The main view
    – Lists all available styles.
    – Controls all view properties, like one-level vs. hierarchical, and things like preview.

• A filter layer
    – Just filters the style list of the main view.
    – Doesn’t affect the view properties.


Properties & characteristics:

• The sidebar should provide a simple switch for toggling between one-level or hierarchical view. Maybe like the current checkbox for activation of previews, or better via just an icon-switch – like most settings inside the properties pane of the sidebar are implemented.

• The filter “used styles” should be a general filter on top of all the other filters (as this filter is useful in combination with other filters) and therefore also should be accessible via a switch in the sidebar.

• Optional: Advanced filter selection
    – If the window height isn’t that tall (or if the list contains a lot of entries, which would take over most space of the pane area), the filters should be accessible via a ComboBox (like it is implemented now).
    – If the window is tall enough (or if the list is small enough), the filter selectors should be shown as a full list at the bottom, so that the users can switch between filters via just one click.


Opinions?

Steps to Reproduce:
.

Actual Results:  
.

Expected Results:
.


Reproducible: Always


User Profile Reset: No



Additional Info:


User-Agent: Mozilla/5.0 (X11; Fedora; Linux x86_64; rv:57.0) Gecko/20100101 Firefox/57.0
Comment 1 Heiko Tietze 2018-01-31 09:34:43 UTC
100% agree we the clear separation of viewing modes from filters.
Comment 2 Eric Bright 2018-03-20 18:17:13 UTC
Created attachment 140753 [details]
Hierarchical tree branch view in another word-processor

Hierarchical tree lines that connects the branches as they appear nested inside one another also make the Hierarchical view a lot more readable. This screenshot  shows how it is done in another word-processor.
Comment 3 Heiko Tietze 2018-03-20 19:54:57 UTC
(In reply to Eric Bright from comment #2)
> Hierarchical tree lines that connects the branches as they appear nested...

Doesn't the look and feel of trees depend on your system theme?
Comment 4 Eric Bright 2018-03-20 21:14:51 UTC
Created attachment 140761 [details]
Applied Styles view in LibreOffice Writer version 6.0.2.1 on Windows 10 (as of 2018-03-20)

(In reply to Heiko Tietze from comment #3)
> (In reply to Eric Bright from comment #2)
> > Hierarchical tree lines that connects the branches as they appear nested...
> 
> Doesn't the look and feel of trees depend on your system theme?

I am not sure. On my system, a Windows 10, x64, it looks awful. I attached another screenshot, which shows how it looks like on my system at best.
Comment 5 Eric Bright 2018-03-20 21:26:31 UTC
A huge drawback of the current, messy hierarchical view is that since it is not usable as it is due to all styles being listed whether or not they are applied, one cannot easily know which paragraph style is inheriting properties from which other style in a glance. This causes a huge problem later when you want to change levels or other organizational settings and suddenly see seemingly unrelated styles are being "randomly" changed as a consequence (of course it is not random, and they are inheriting properties from the style you just changed, but you cannot see that). This, in my opinion, defeats the whole purpose of the hierarchical view.

With a clean hierarchical view, as is suggested in the OP, and proper branch lines that visually connect and separate each branch from others, for the Applied Styles, one can easily see and understand what is going on.
Comment 6 Eric Bright 2018-03-20 21:36:15 UTC
Created attachment 140762 [details]
Heirarchical view in LibreOffice Writer version 6.0.2.1 on Windows 10 (as of 2018-03-20)
Comment 7 Heiko Tietze 2018-03-20 23:31:36 UTC
(In reply to Eric Bright from comment #5)
> A huge drawback of the current, messy hierarchical view is that since it is
> not usable as it is due to all styles being listed whether or not they are
> applied...

Now you mix-up different topics. Let's focus on the design question, showing tree lines to support the hierarchy. 

The option Hierarchical being orthogonal or rather additional to the filters All styles, Applied, Hidden etc. is a different question and likely discussed in other tickets.
Comment 8 Frank Brütting 2018-03-26 22:48:22 UTC
Actually, my bug report was about splitting the current list up in a) filters and b) view/sorting modes. I for example would like to able to use the “used styles” filter (maybe via a checkbox?) in conjunction with every selectable style of that list. The tree lines would be a nice addition though, but are not really my concern. :)
Comment 9 Heiko Tietze 2018-03-27 06:58:08 UTC
Okay, so let's go with a checkbox [x] Hierarchical next to [x] Show Preview that allows to show any filtered selection in a tree. And of course, Hierarchical should be removed from the list.

The question on tree visualization with or without help lines should be separated.
Comment 10 Frank Brütting 2018-03-27 22:41:31 UTC
Would you mind adding an additional checkbox “[x] used styles”?
Comment 11 Heiko Tietze 2018-03-28 07:43:59 UTC
In reply to zyklon87 from comment #10)
> Would you mind adding an additional checkbox “[x] used styles”?

Yes, good point.
Comment 12 Dieter 2020-09-24 06:15:00 UTC
*** Bug 131556 has been marked as a duplicate of this bug. ***
Comment 13 Dieter 2021-10-10 05:27:35 UTC
*** Bug 144727 has been marked as a duplicate of this bug. ***
Comment 14 Dieter 2022-10-07 15:31:01 UTC
*** Bug 151109 has been marked as a duplicate of this bug. ***